/* gcc -Wall -fPIC -shared -o uname_i686.so uname_i686.c -ldl */

/* for RTLD_NEXT */
#define _GNU_SOURCE 1

#include <dlfcn.h>

#include <sys/utsname.h>
#include <string.h>
#include <errno.h>

typedef int (*uname_fn_t)(struct utsname *buf);

static uname_fn_t orig_uname = NULL;

int uname(struct utsname *buf)
{
    int ret;

    if (orig_uname == NULL) {
        orig_uname = (uname_fn_t) dlsym(RTLD_NEXT, "uname");
    }

    ret = orig_uname(buf);
    if (ret == 0) {
        if (strlen(buf->machine) < 4) {
            errno = EINVAL;
            ret = -1;
        }

        strncpy(buf->machine, "i686", sizeof("i686"));
    }
    
    return ret;
}
